﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace PopupCellTypeDemo_Modal
{
    public partial class SearchForModal : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (IsPostBack)
                return;

            // 得到Spread中ActiveCell的值
            string searchkey = Request.QueryString["searchkey"].ToString();
            this.txtSearch.Text = searchkey;

            this.FpSpread1.ProcessTab = false;
            this.FpSpread1.ActiveSheetView.AllowPage = false;
            // 加载可供使用的全部数据
            FillListBox(searchkey,true);

            FarPoint.Web.Spread.GeneralCellType tct = new FarPoint.Web.Spread.GeneralCellType();
            tct.AllowWrap = false;

            this.FpSpread1.Columns[0].HorizontalAlign = HorizontalAlign.Center;
            this.FpSpread1.Columns[0, 1].Renderer = tct;            
        }

        protected void btnSearch_Click(object sender, EventArgs e)
        {
            // 返回符合检索条件的所有数据
            FillListBox(txtSearch.Text,false);
        }

        private void FillListBox(string key, bool isLoadAll)
        {

            #region /*=================实际项目中可能是从数据库等外部数据源加载数据，这里仅创建了一个内存数据表=================*/
            DataTable dt = new DataTable();

            dt.Columns.Add("编号");
            dt.Columns.Add("名称");
            dt.Columns.Add("明细");

            dt.Rows.Add("100101", "产品研发", "用于研发新产品，购买设备、耗材等费用");
            dt.Rows.Add("100102", "市场推广", "用于产品的市场推广活动，网络宣传、纸张印刷、参加展会等费用");
            dt.Rows.Add("100103", "接待客户", "用于接待客户、同事等费用");
            dt.Rows.Add("100104", "差旅补助", "用于差旅补助，住宿、餐费、生活用品、交通费等");
            dt.Rows.Add("100105", "公司活动", "用于公司活动，旅游、运动会等费用");
            dt.Rows.Add("100106", "部分活动", "用于部门级别的活动，旅游、聚餐等费用");
            dt.Rows.Add("100107", "工会福利", "用于工会给员工提供的福利，节假日礼物、生日祝福、新婚祝福等费用");
            dt.Rows.Add("100108", "办公用品", "用于公司集体采购办公用品，笔记本、笔、文件夹等费用");
            dt.Rows.Add("100109", "体育用品", "用于各个体育俱乐部活动，羽毛球、足球、篮球等费用");
            dt.Rows.Add("100110", "员工培训", "用于员工培训的专项经费，如微软考生、日语考生、项目管理培训等费用");            
            #endregion


            // 如果没有指定检索关键字，就加载可供使用数据
            if (isLoadAll || string.IsNullOrEmpty(key))
                this.FpSpread1.DataSource = dt;
            else
            {
                DataView view = dt.DefaultView;
                view.RowFilter = String.Format("名称 LIKE '%{0}%'", key);
                this.FpSpread1.DataSource = view;
            }

            for (int i = 0; i < FpSpread1.ActiveSheetView.RowCount; i++)
            {
                if (FpSpread1.ActiveSheetView.Cells[i, 1].Text.StartsWith(key))
                {
                    FpSpread1.ActiveSheetView.ActiveRow = i;
                    break;
                }
            }

            this.FpSpread1.ActiveSheetView.Columns[0].Width = 120;
            this.FpSpread1.ActiveSheetView.Columns[1].Width = 180;
            this.FpSpread1.ActiveSheetView.Columns[2].Width = 200;
        }


        protected override void Render(HtmlTextWriter writer)
        {
            Table table = FpSpread1.FindControl("viewPort") as Table;
            if (table != null)
            {
                table.Attributes.Add("ondblclick", "SetCellvalue()");
            }
            base.Render(writer);
        }
        protected void FpSpread1_CreateButton(object sender, FarPoint.Web.Spread.CreateButtonEventArgs e)
        {
            if (e.Command == "Print")
            {
                e.Visible = false;
            }
        }
    }
}